<?php

/**
 * tercero actions.
 *
 * @package    controlComisiones
 * @subpackage tercero
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class terceroActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'COM_TERCERO',
        'COM_TIPO_COMISIONADO',
        'TIPO_DOCUMENTO',
        'TS_BN',
        'TS_TC',
        'COM_COMISIONADO'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'COM_TIPO_COMISIONADO' =>
        array(
            'tipter' => 'COM_TERCERO'
        ),
        'TIPO_DOCUMENTO' =>
        array(
            'id_tipo_doc' => 'COM_TERCERO'
        ),
        'TS_BN, LEFT' =>
        array(
            'banco-id_bn' => 'COM_TERCERO'
        ),
        'TS_TC, LEFT' =>
        array(
            'tipo_cuenta-id' => 'COM_TERCERO'
        ),
        'COM_COMISIONADO, LEFT' =>
        array(
            'id_tercero' => 'COM_TERCERO'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'COM_TERCERO' =>
        array(
            'id_tercero' => 'id_tercero',
            'num_doc' => 'num_doc',
            'nombre' => 'nombre',
            'email' => 'email',
            'estado' => 'estado',
            'sueldo' => 'sueldo',
            'tipter' => 'tipter',
            'telefono' => 'telefono',
            'celular' => 'celular',
            'banco' => 'banco',
            'numero_cuenta' => 'numero_cuenta',
            'tipo_cuenta' => 'tipo_cuenta',
            'cargo' => 'cargo',
            'id_tipo_doc' => 'id_tipo_doc',
            'numero_contrato' => 'numero_contrato',
            'aplica_iva' => 'aplica_iva',
            'porcentaje_iva' => 'porcentaje_iva',
            'fecha_nacimiento' => 'fecha_nacimiento',
            'num_doc,||, - ,||,nombre' => 'completo_tercero',
            'aplica_ica' => 'aplica_ica',
            'direccion'=>'direccion'
        ),
        'COM_TIPO_COMISIONADO' =>
        array(
            'descripcion' => 'descripcion_tipcom',
            'tipter,||, - ,||,descripcion' => 'completo_tipcom'
        ),
        'TIPO_DOCUMENTO' =>
        array(
            'descripcion' => 'descripcion_tipdoc',
            'abreviacion' => 'abreviacion'
        ),
        'TS_BN' =>
        array(
            'descripcion' => 'nombre_banco'
        ),
        'TS_TC' =>
        array(
            'descripcion' => 'des_tipo_cuenta'
        )
    ); //por cada tabla especificar los campos del select
    protected $fields_orderBy = array(
    ); //campos para el ordenamiento de la consulta
    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'COM_TERCERO' =>
        array(
            'id_tercero,a' => array('!=' => array(-1)),
            'id_tercero,b' => array('=' => array('id_tercero')),
            'num_doc' => array('=' => array('num_doc')),
            'tipter' => array('=' => array('tipter')),
            'id_tipo_doc' => array('=' => array('id_tipo_doc')),
            'estado' => array('=' => array('estado')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        ),
        'COM_COMISIONADO' =>
        array(
            'id_comision' => array('=' => array('id_comision'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(
        'COM_TERCERO' =>
        array(
            'num_doc' => array('LIKEALL' => array('input', '%')),
            'nombre' => array('LIKEALLPLUS' => array('input', '%'))
        )
    ); // filtros de condicion or
    protected $query_qualifier = 'DISTINCT'; //Variable para el sql para eliminar filas repetidas
//    protected $fields_orderBy = array(
//        'num_doc', 'codigo_clase', 'fecha_ingreso'
//    ); //campos para el ordenamiento de la consulta

    /*
     * Variable manejo de log
     */
    //true - consulta de menu administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Perfiles';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;
    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_tercero'; //identificador de la tabla
    protected $id_names = array('id_tercero'); //llave primaria
    protected $field_names = array('num_doc', 'nombre', 'email', 'estado', 'sueldo',
        'tipter', 'telefono', 'celular', 'banco', 'numero_cuenta', 'tipo_cuenta', 'cargo', 'id_tipo_doc',
        'numero_contrato', 'aplica_iva', 'porcentaje_iva', 'fecha_nacimiento','aplica_ica','direccion'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'COM_TERCERO'; //tabla en la cual se aplican los cambios 
    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_tercero'; //identificador unico de la tabla

    protected function postprocessRequest($Action, \sfWebRequest $request, $list_data_post) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);
        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {


            //CREAR TERCERO EN INTERCEROS

            $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
            $this->conn->beginTransaction();
            try {


                $num_doc = $list_data_post[0]['num_doc'];
                $nombre = $list_data_post[0]['nombre'];
                $email = $list_data_post[0]['email'];
                $id_tipo_doc = $list_data_post[0]['id_tipo_doc'];

                $sql = <<<EOD
select * from tipo_documento  where id_tipo_doc = '$id_tipo_doc' 
EOD;

                $records = CN_TABLE::executeSQL($sql);

                $id_tip_ter = $records[0]['id_tip_ter'];
                $id_nat_jur = $records[0]['id_nat_jur'];
                $id_tipo_identificacion = $records[0]['id_tipo_identificacion'];


                $sql = <<<EOD
INSERT INTO INTERCEROS (ID_NAT_JUR,ID_TIP_TER,ID_TIPO_DOC,NUM_DOC,RAZON_SOC,ESTADO_TER)
   VALUES($id_nat_jur,$id_tip_ter,$id_tipo_identificacion,'$num_doc','$nombre',1)
EOD;
                $this->conn->execute($sql);

                $this->conn->commit();
            } catch (Exception $ex) {
                //ROLLBACK DE TODAS LAS TRANSACCIONES EN CASO DE QUE OCURRA ALGUN ERROR
                $this->conn->rollback();
            }
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function preprocessRequest($Action, \sfWebRequest $request) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function validateAdd(\sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */
        $num_doc = $request['num_doc'];

        $sql = <<<EOD
select count(id_tercero) as cantidad from com_tercero where num_doc = '$num_doc' 
EOD;

        $records = CN_TABLE::executeSQL($sql);
        $cantidad = $records[0]['cantidad'];

        /*
         *  Generar errores en $errors
         */
        if ($cantidad > 0) {
            $errors['mensaje'] = "El Comisionado ya se encuentra registrad, favor verificar.";
            $errors['servicio'] = "Tercero";
        }

        return $errors;
    }

    protected function validateRemove(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateUpdate(\sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */


        return $errors;
    }

}
